﻿using System;
using System.Configuration; // Reference System.Configuration
using System.Xml;

namespace Accentient
{
  class Program
  {
    static void Main(string[] args)
    {
      try
      {
        Console.WriteLine("MOC 20497 Setup Utility v1.0");
        Console.WriteLine("");

        // Read config settings

        string AccountURL = ConfigurationManager.AppSettings["AccountUrl"];
        string TeamProject = ConfigurationManager.AppSettings["TeamProject"];
        string MicrosoftAccountAlias = ConfigurationManager.AppSettings["MicrosoftAccountAlias"];
        string MicrosoftAccountPwd = ConfigurationManager.AppSettings["MicrosoftAccountPassword"];
        string ConfigFile = ConfigurationManager.AppSettings["InputFile"];

        Console.WriteLine("Configuring environment for LAB 2");
        Console.WriteLine("");
        Console.WriteLine(" Account URL ....... " + AccountURL);
        Console.WriteLine(" Project ........... " + TeamProject);
        Console.WriteLine(" Microsoft Acount .. " + MicrosoftAccountAlias);
        Console.WriteLine(" Password .......... " + MicrosoftAccountPwd);
        Console.WriteLine(" Config file ....... " + ConfigFile);
        Console.WriteLine("");

        // Confirm input

        Console.Write("Is the above information correct? (y/n): ");
        ConsoleKeyInfo info = Console.ReadKey();
        Console.WriteLine("");
        if (info.KeyChar == 'n' || info.KeyChar == 'N')
        {
          Console.WriteLine("");
          Console.WriteLine("Please edit the app.config file and make any necessary changes.");
          return;
        }

        Console.WriteLine("");
        Console.Write("Remove existing iterations and create new ones? (y/n): ");
        info = Console.ReadKey();
        Console.WriteLine("");
        if (info.KeyChar == 'y' || info.KeyChar == 'Y')
        {
          Console.WriteLine("");
          Console.WriteLine(" Removing iterations");
          TFSHelper.RemoveIterations();
          Console.Write(" Creating iterations ");
          TFSHelper.CreateIterations();
          Console.WriteLine(" Setting iterations for planning");
          TFSHelper.SetPlanningIterations();
        }

        Console.WriteLine("");
        Console.Write("Remove existing areas and create new ones? (y/n): ");
        info = Console.ReadKey();
        Console.WriteLine("");
        if (info.KeyChar == 'y' || info.KeyChar == 'Y')
        {
          Console.WriteLine("");
          Console.WriteLine(" Removing areas");
          TFSHelper.RemoveAreas();
          Console.Write(" Creating areas ");
          TFSHelper.CreateAreas();
        }

        Console.WriteLine("");
        Console.Write("Destroy existing work items and create new ones? (y/n): ");
        info = Console.ReadKey();
        Console.WriteLine("");
        if (info.KeyChar == 'y' || info.KeyChar == 'Y')
        {
          Console.WriteLine("");
          Console.WriteLine(" Destroying work items");
          TFSHelper.DestroyWorkItems(true);
          Console.Write(" Creating work items ");
          TFSHelper.CreateWorkItems();
        }
      }
      catch (Exception ex)
      {
        Console.WriteLine("Error: " + ex.Message);
      }
      finally
      {
        Console.WriteLine("");
        Console.WriteLine("Press Enter to continue.");
        Console.ReadLine();
      }
    }
  }
}